<template>
  <client-only>
    <div class="module module-slider-testimonials mobile-fullwidth">
      <atom-slider
        ref="flickity"
        class="main-carousel flickity"
        :options="flickityOptions"
      >
        <div
          v-for="(slide, index) in data.slides"
          :key="index"
          class="carousel-cell slide"
        >
          <div class="row">
            <div
              class="col-12 col-md-5 col-xl-4 offset-xl-1"
              :class="[
                { 'offset-lg-1': data.imgOrder !== null },
                { 'order-md-2': data.imgOrder !== null },
              ]"
            >
              <atom-image
                class="slider-image cover"
                :image="slide.bild"
                :ratio="getRatio"
                :lazyload="false"
                sizes="(min-width: 768px) and (max-width: 1024px) 95vw,
                  (min-width: 1025px) and (max-width: 1488px) 79vw,
                  (min-width: 1489px) 1192px,
                  100vw"
              />
            </div>
            <div
              class="col-12 col-md-6 col-lg-5 offset-lg-1"
              :class="[
                { 'offset-md-1': data.imgOrder !== null },
                { 'order-md-1': data.imgOrder !== null },
              ]"
            >
              <figure class="text-wrapper">
                <blockquote>
                  <p class="zitat h2">»{{ slide.zitat }}«</p>
                </blockquote>
                <figcaption class="autor">{{ slide.autor }}</figcaption>
              </figure>
            </div>
          </div>
        </div>
      </atom-slider>
      <div v-if="isMobile" class="flickity-mobile-controls">
        <button
          class="flickity-button flickity-prev-next-button previous"
          type="button" aria-label="Previous"
          @click="$refs.flickity.previous()"
        >
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
            <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
          </svg>
        </button>
        <ol class="flickity-page-dots">
          <li
            v-for="(slide, index) in data.slides"
            :key="index"
            class="dot"
            :class="{ 'is-selected': selectedSlide === index }"
            @click="$refs.flickity.select(index)"
          ></li>
        </ol>
        <button
          class="flickity-button flickity-prev-next-button next"
          type="button" aria-label="Next"
          @click="$refs.flickity.next()"
        >
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
            <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
          </svg>
        </button>
      </div>
      <button
        v-if="isDesktop"
        class="flickity-button flickity-prev-next-button flickity-prev-next-button-desktop previous"
        type="button" aria-label="Previous"
        @click="$refs.flickity.previous()"
      >
        <svg class="flickity-button-icon" viewBox="0 0 100 100">
          <path d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z" class="arrow"></path>
        </svg>
      </button>
      <button
        v-if="isDesktop"
        class="flickity-button flickity-prev-next-button flickity-prev-next-button-desktop next"
        type="button" aria-label="Next"
        @click="$refs.flickity.next()"
      >
        <svg class="flickity-button-icon" viewBox="0 0 100 100">
          <path d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z" class="arrow" transform="translate(100, 100) rotate(180) "></path>
        </svg>
      </button>
    </div>
  </client-only>
</template>

<script>
export default {
  props: {
    data: {
      type:Object,
      default: () => {},
    }
  },
  data() {
    return {
      flickityOptions: {
          wrapAround: true,
          cellAlign: 'left',
          autoPlay: false,
          contain: true,
          selectedAttraction: 0.025,
          friction: 0.3,
          pageDots: false,
          prevNextButtons: false,
          adaptiveHeight: true,
          arrowShape: 'M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z',
          // any options from Flickity can be used
      },
      selectedSlide: 0,
    };
  },
  computed: {
    getRatio() {
      if (this.$mq === 'xs' ||
        this.$mq === 'sm') {
          return '1x1';
      }

      return '9x13';
    },
    isMobile() {
      return this.$mq === 'sm' || this.$mq === 'xs';
    },
    isDesktop() {
      return this.$mq !== 'sm' && this.$mq !== 'xs';
    },
  },
  mounted() {
    this.$nextTick(() => {
      this.$nextTick(() => {
        this.$refs.flickity.on('change', (index) => {
          this.selectedSlide = index;
        });
      });
    });
  },
};
</script>

<style lang="scss">
.module-slider-testimonials {
  position: relative;
  padding: 0;

  .flickity-viewport {
    transition: height 0.35s;
  }

  .zitat {
    font-size: 2rem;
    line-height: 1.25em;
    margin-top: 1rem;
  }

  .autor {
    font-size: 1rem;
    line-height: 1.5em;
    text-transform: uppercase;
    margin-top: 2rem;

    @include media-breakpoint-up(md) {
      margin-top: 3rem;
    }
  }
}
</style>
